<?php 

namespace Teknisa\MAN\Controllers;
use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Teknisa\MAN\Utilities;
use Teknisa\MAN\Services\CadTipoCampanhaService;

class CadTipoCampanha extends CrudWithParameterBag {
    

    protected $dataSourceName = 'cadtipocampanha';
    protected $parameterBagColumns = array('NRORG');
    protected $cadTipoCampanhaService;
    
    public function __construct ( ParameterBag $parameterBag, Manager $dataSourceManager, CadTipoCampanhaService $cadTipoCampanhaService) {
        $this->cadTipoCampanhaService = $cadTipoCampanhaService;        
        parent::__construct($dataSourceManager,$parameterBag);
    }
    
     public function save(DTO\Request\DataSet $request, DTO\Response $response) {
        $row = $request->getDataSet()->getRows(); 
        $this->dataSourceName='cadtipocampanha';
        if($row[0]["__is_new"]){
            $NRORG = $row[0]['NRORG'];
            $CDTPCAMPANHA = $row[0]['CDTPCAMPANHA'];
            $params = array(
                ':NRORG' => $NRORG,
                ':CDTPCAMPANHA' => $CDTPCAMPANHA);
            $count = $this->cadTipoCampanhaService->verificaCode($params);

            if($count > 0){
			    $error[0] = "Código já existente";
			    $response->addDataSet(new DataSet('Error', $error));
                throw new \Exception("Código já existente!");   
            }
        }
        try {
            $dataSet = $request->getDataSet();
            $dataSet->setDataSourceName($this->dataSourceName);
            $persistedRows = $this->dataSourceManager->persist($dataSet);
            $response->addDataSet(new DataSet($this->dataSourceName, $persistedRows));
        } catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }
    
    public function deleteWithoutNotification ($request, $response) {
		try {
            $dataSet = $request->getDataSet();
            $dataSet->setDataSourceName($this->dataSourceName);
            $deletedRows = $this->dataSourceManager->delete($dataSet);
            $response->addDataSet(new DataSet($this->dataSourceName, $deletedRows));
        } catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode(), $e->getTraceAsString()));
        }
    }
    
    public function getNextCode(DTO\Request\Row $request, DTO\Response $response) {
        $data = $request->getRow();
        $cdcampanha = $this->cadTipoCampanhaService->nextCodeCampanha($data['NRORG']);
        $arraycdcampanha = array( 
                'CDTPCAMPANHA' => str_pad($cdcampanha, 5, '0', STR_PAD_LEFT));
        $response->addDataSet(
                new DataSet('CodigoTipoCampanha', $arraycdcampanha));
    }
    
    
}
    
//     public function save($request, $response) {
// 	   	try {
//             $dataSet = $request->getDataSet();
//             $dataSet->setDataSourceName($this->dataSourceName);
//             $persistedRows = $this->dataSourceManager->persist($dataSet);
//             $response->addDataSet(new DataSet($this->dataSourceName, $persistedRows));
//             $nrPersistedRows = count($persistedRows);
//         } catch (\Exception $e) {
//             $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode(), $e->getTraceAsString()));
//         }
// 	}

/*    protected $dataSourceName = 'cadtipocampanha';
    protected $service;
    protected $parameterBag;
    protected $crudService;
    protected $dataSourceParamBag;
    
     public function __construct($crudService, ParameterBag $dataSourceParamBag,
     Manager $dataSourceManager, CadTipoCampanhaService $service) {
		parent::__construct($crudService, $dataSourceParamBag);
		$this->service = $service;

		$this->dataSourceParamBag = $dataSourceParamBag;
	}
	
       
    */