<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class LancamentoCliConsumidorService {

	protected $entityManager; 
	
	public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;

    }

	public function buscaDados($cdfilial, $dtinicial, $dtfinal, $produtoinicial, $produtofinal, $cdloja, $cdcliente, $nrorg, $idrelatorio, $cdconsumidor) {

	    $params = array(
     	":CDFILIAL" => (is_null($cdfilial)) ? "" : $cdfilial,
     	":CDLOJA" => (is_array($cdloja)  && count($cdloja) != 0) ? implode('_' ,$cdloja) : "",
     	":CDCLIENTE" => (is_array($cdcliente)  && count($cdcliente) != 0) ? implode('_' ,$cdcliente) : "",
     	":CDCONSUMIDOR" => (is_array($cdconsumidor)  && count($cdconsumidor) != 0) ? implode('_' ,$cdconsumidor) : "",
     	":CDPRODINI" => $produtoinicial,
     	":CDPRODFIM" => $produtofinal,
     	":DTLANCINI" => $dtinicial,
     	":DTLANCFIN" => $dtfinal,
     	":CDPRODUTO" => null,
     	":TCDPRODUTO" => ($produtoinicial) ? "N" : "T",
     	":TCDFILIAL" => (is_null($cdfilial)) ?  "T" : "N",
     	":TCDLOJA" => (is_array($cdloja)  && count($cdloja) != 0) ?  "N" : "T",
     	":TCDCLIENTE" => (is_array($cdcliente)  && count($cdcliente) != 0) ?  "N" : "T",
     	":TCDCONSUMIDOR" => (is_array($cdconsumidor)  && count($cdconsumidor) != 0) ?  "N" : "T",
     	":NRORG" => $nrorg
 		);
 		ini_set('memory_limit', '3G');
        
 		switch($idrelatorio){
            case 0:
 				$response = $this->entityManager->getConnection()->fetchAll(self::BUSCA_REL_CONS_SODEXO_PADRAO, $params);
		        return $response;
		    break;

			case 1:
				$response = $this->entityManager->getConnection()->fetchAll(self::BUSCA_REL_CONS_SODEXO_VIQUA, $params);
				return $response;
			break;
			case 2:
				$response = $this->entityManager->getConnection()->fetchAll(self::BUSCA_REL_CONS_SODEXO_VALMET, $params);
				return $response;
			break;
			case 3:
				$response = $this->entityManager->getConnection()->fetchAll(self::BUSCA_REL_CONS_SODEXO_VALEO, $params);
				return $response;
			break;
			case 4:
				$response = $this->entityManager->getConnection()->fetchAll(self::BUSCA_REL_CONS_SODEXO_TOLEDO, $params);
				return $response;
			break;
 		}

	}

	const BUSCA_REL_CONS_SODEXO_PADRAO = "
        SELECT   
            SUBSTR(LPAD(CO.CDCONSUMIDOR,21,'0'),12,10) AS CDCONSUMIDOR,
            SUBSTR(RPAD(CO.NMCONSUMIDOR,40,' '),01,40) AS NMCONSUMIDOR,
            TRIM(REPLACE(TO_CHAR(SUM(MO.VRMOVCLI), '0000000.00'),'.',',')) AS VRMOVCLI
        FROM 
            VENDA VE, MOVICLIE MO, CONSUMIDOR CO, CLIENTE CL
        WHERE
            (VE.CDFILIAL     = :CDFILIAL    ) AND
            (VE.IDSITUVENDA  = 'O'            ) AND
            (VE.DTENTRVENDA BETWEEN :DTLANCINI AND :DTLANCFIN) AND
            (VE.CDFILIAL     = MO.CDFILIAL    ) AND
            (VE.CDCAIXA      = MO.CDCAIXA     ) AND
            (VE.NRSEQVENDA   = MO.NRSEQVENDA  ) AND
            (CO.CDCLIENTE    = MO.CDCLIENTE   ) AND
            (CO.CDCONSUMIDOR = MO.CDCONSUMIDOR) AND
            (CL.CDCLIENTE    = MO.CDCLIENTE   ) AND
            ((INSTR(:CDLOJA      , VE.CDFILIAL||VE.CDLOJA       ) <> 0) OR (:TCDLOJA       = 'T')) AND
            ((INSTR(:CDCLIENTE   , CL.CDCLIENTE                 ) <> 0) OR (:TCDCLIENTE    = 'T')) AND
            ((INSTR(:CDCONSUMIDOR, CO.CDCLIENTE||CO.CDCONSUMIDOR) <> 0) OR (:TCDCONSUMIDOR = 'T'))
        GROUP BY
            SUBSTR(LPAD(CO.CDCONSUMIDOR,21,'0'),12,10),
            SUBSTR(RPAD(CO.NMCONSUMIDOR,40,' '),01,40)
        ORDER BY
            SUBSTR(LPAD(CO.CDCONSUMIDOR,21,'0'),12,10)
    ";

    const BUSCA_REL_CONS_SODEXO_VIQUA = "
        SELECT
           CO.CDCLIENTE AS CDCLI,   
           CO.CDCONSUMIDOR,
           CO.NMCONSUMIDOR,
           :DTLANCINI AS DTINI,
           :DTLANCFIN AS DTFIN,
           SUM(MO.VRMOVCLI) AS VRMOVCLI
        FROM 
           VENDA VE, MOVICLIE MO, CONSUMIDOR CO, CLIENTE CL
        WHERE
           (VE.CDFILIAL     = :CDFILIAL    ) AND
           (VE.IDSITUVENDA  = 'O'            ) AND
           (VE.DTENTRVENDA BETWEEN :DTLANCINI AND :DTLANCFIN) AND
           (VE.CDFILIAL     = MO.CDFILIAL    ) AND
           (VE.CDCAIXA      = MO.CDCAIXA     ) AND
           (VE.NRSEQVENDA   = MO.NRSEQVENDA  ) AND
           (CO.CDCLIENTE    = MO.CDCLIENTE   ) AND
           (CO.CDCONSUMIDOR = MO.CDCONSUMIDOR) AND
           (CL.CDCLIENTE    = MO.CDCLIENTE   ) AND
           ((INSTR(:CDLOJA      , VE.CDFILIAL||VE.CDLOJA       ) <> 0) OR (:TCDLOJA       = 'T')) AND
           ((INSTR(:CDCLIENTE   , CL.CDCLIENTE                 ) <> 0) OR (:TCDCLIENTE    = 'T')) AND
           ((INSTR(:CDCONSUMIDOR, CO.CDCLIENTE||CO.CDCONSUMIDOR) <> 0) OR (:TCDCONSUMIDOR = 'T'))
        GROUP BY
           CO.CDCLIENTE,   
           CO.CDCONSUMIDOR,
           CO.NMCONSUMIDOR
        ORDER BY
           CO.CDCLIENTE,
           CO.CDCONSUMIDOR
   ";
   
   const BUSCA_REL_CONS_SODEXO_VALMET = "
        SELECT   
           LTRIM(CO.CDCONSUMIDOR,'0') AS CDCONSUMIDOR,
           CO.NMCONSUMIDOR,
           TO_CHAR(SUM(MO.VRMOVCLI),'999999999990d00') AS VRMOVCLI
        FROM 
           VENDA VE, MOVICLIE MO, CONSUMIDOR CO, CLIENTE CL
        WHERE
           (VE.CDFILIAL     = :CDFILIAL    ) AND
           (VE.IDSITUVENDA  = 'O'            ) AND
           (VE.DTENTRVENDA BETWEEN :DTLANCINI AND :DTLANCFIN) AND
           (VE.CDFILIAL     = MO.CDFILIAL    ) AND
           (VE.CDCAIXA      = MO.CDCAIXA     ) AND
           (VE.NRSEQVENDA   = MO.NRSEQVENDA  ) AND
           (CO.CDCLIENTE    = MO.CDCLIENTE   ) AND
           (CO.CDCONSUMIDOR = MO.CDCONSUMIDOR) AND
           (CL.CDCLIENTE    = MO.CDCLIENTE   ) AND
           ((INSTR(:CDLOJA      , VE.CDFILIAL||VE.CDLOJA       ) <> 0) OR (:TCDLOJA       = 'T')) AND
           ((INSTR(:CDCLIENTE   , CL.CDCLIENTE                 ) <> 0) OR (:TCDCLIENTE    = 'T')) AND
           ((INSTR(:CDCONSUMIDOR, CO.CDCLIENTE||CO.CDCONSUMIDOR) <> 0) OR (:TCDCONSUMIDOR = 'T'))
        GROUP BY
           LTRIM(CO.CDCONSUMIDOR,'0'),
           CO.NMCONSUMIDOR
        ORDER BY
           LTRIM(CO.CDCONSUMIDOR,'0')
   ";
   
   
    const BUSCA_REL_CONS_SODEXO_VALEO = "
        SELECT
           CO.CDCLIENTE AS CDCLI,   
           CO.CDCONSUMIDOR,
           CO.NMCONSUMIDOR,
           CO.CDIDCONSUMID,
           CO.CDCCUSCLIE,
           SUM(MO.VRMOVCLI) AS VRMOVCLI
        FROM 
           VENDA VE, MOVICLIE MO, CONSUMIDOR CO, CLIENTE CL
        WHERE
           (VE.CDFILIAL     = :CDFILIAL    ) AND
           (VE.IDSITUVENDA  = 'O'            ) AND
           (VE.DTENTRVENDA BETWEEN :DTLANCINI AND :DTLANCFIN) AND
           (VE.CDFILIAL     = MO.CDFILIAL    ) AND
           (VE.CDCAIXA      = MO.CDCAIXA     ) AND
           (VE.NRSEQVENDA   = MO.NRSEQVENDA  ) AND
           (CO.CDCLIENTE    = MO.CDCLIENTE   ) AND
           (CO.CDCONSUMIDOR = MO.CDCONSUMIDOR) AND
           (CL.CDCLIENTE    = MO.CDCLIENTE   ) AND
           ((INSTR(:CDLOJA      , VE.CDFILIAL||VE.CDLOJA       ) <> 0) OR (:TCDLOJA       = 'T')) AND
           ((INSTR(:CDCLIENTE   , CL.CDCLIENTE                 ) <> 0) OR (:TCDCLIENTE    = 'T')) AND
           ((INSTR(:CDCONSUMIDOR, CO.CDCLIENTE||CO.CDCONSUMIDOR) <> 0) OR (:TCDCONSUMIDOR = 'T'))
        GROUP BY
           CO.CDCLIENTE,   
           CO.CDCONSUMIDOR,
           CO.NMCONSUMIDOR,
           CO.CDIDCONSUMID,
           CO.CDCCUSCLIE
        ORDER BY
           CO.CDCLIENTE,
           CO.CDCONSUMIDOR
   ";
   
    const BUSCA_REL_CONS_SODEXO_TOLEDO = "
        SELECT   
           SUBSTR(LPAD(CO.CDCONSUMIDOR,21,'0'),12,10) AS CDCONSUMIDOR,
           SUBSTR(RPAD(CO.NMCONSUMIDOR,40,' '),01,40) AS NMCONSUMIDOR,
           TRIM(REPLACE(TO_CHAR(SUM(MO.VRMOVCLI), '0000000.00'),'.',',')) AS VRMOVCLI
        FROM 
           VENDA VE, MOVICLIE MO, CONSUMIDOR CO, CLIENTE CL
        WHERE
           (VE.CDFILIAL     = :CDFILIAL    ) AND
           (VE.IDSITUVENDA  = 'O'            ) AND
           (VE.DTENTRVENDA BETWEEN :DTLANCINI AND :DTLANCFIN) AND
           (VE.CDFILIAL     = MO.CDFILIAL    ) AND
           (VE.CDCAIXA      = MO.CDCAIXA     ) AND
           (VE.NRSEQVENDA   = MO.NRSEQVENDA  ) AND
           (CO.CDCLIENTE    = MO.CDCLIENTE   ) AND
           (CO.CDCONSUMIDOR = MO.CDCONSUMIDOR) AND
           (CL.CDCLIENTE    = MO.CDCLIENTE   ) AND
           ((INSTR(:CDLOJA      , VE.CDFILIAL||VE.CDLOJA       ) <> 0) OR (:TCDLOJA       = 'T')) AND
           ((INSTR(:CDCLIENTE   , CL.CDCLIENTE                 ) <> 0) OR (:TCDCLIENTE    = 'T')) AND
           ((INSTR(:CDCONSUMIDOR, CO.CDCLIENTE||CO.CDCONSUMIDOR) <> 0) OR (:TCDCONSUMIDOR = 'T'))
        GROUP BY
           SUBSTR(LPAD(CO.CDCONSUMIDOR,21,'0'),12,10),
           SUBSTR(RPAD(CO.NMCONSUMIDOR,40,' '),01,40)
        ORDER BY
           SUBSTR(LPAD(CO.CDCONSUMIDOR,21,'0'),12,10)
   ";
}  