<?php

namespace Teknisa\MAN\Services;

use Teknisa\MAN\Utilities\Query;

class ProdGrupoPromocionalService {

	protected $entityManager;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager)  {
		$this->entityManager = $entityManager;
	}
	
	public function saveProductsArray($CDGRUPROMOC, $CDPRODUTO, $CDARVPROD, $NMPRODUTO, $NRORG, $CDOPERADOR, $DTATU) {
		$params = array(
			':CDGRUPROMOC'    => $CDGRUPROMOC,
			':CDPRODUTO'      => $CDPRODUTO,
			':CDARVPROD'	  => $CDARVPROD,
			':NMPRODUTO'	  => $NMPRODUTO,
			':NRORG'		  => $NRORG,
			':CDOPERINCLUSAO' => $CDOPERADOR,
			':DTINCLUSAO'     => $DTATU
		);
		$this->entityManager->getConnection()->executeQuery(self::INSERT_PROMOGRUPO, $params);
	}
	
	public function deleteDescProd($CDPRODUTO, $CDGRUPROMOC, $NRORG) {
		$params = array(
			':CDPRODUTO'    => $CDPRODUTO,
			':CDGRUPROMOC' => $CDGRUPROMOC,
			':NRORG'     => $NRORG
		);
		$this->entityManager->getConnection()->executeQuery(self::DELETE_DESGRUPROMPRFIL, $params);
		$this->entityManager->getConnection()->executeQuery(self::DELETE_DESGRUPROMOCPR, $params);
	}
    
    const INSERT_PROMOGRUPO = "
    	INSERT INTO PRODGRUPROMOC
        	(CDPRODUTO, CDGRUPROMOC, NRORG)
    	VALUES
        	(:CDPRODUTO, :CDGRUPROMOC, :NRORG)
    ";
    
    const DELETE_DESGRUPROMPRFIL = "
		DELETE FROM DESGRUPROMPRFIL
		WHERE CDGRUPROMOC = :CDGRUPROMOC AND CDPRODUTO = :CDPRODUTO AND NRORG = :NRORG
    ";
    
    const DELETE_DESGRUPROMOCPR = "
		DELETE FROM DESGRUPROMOCPR
		WHERE CDGRUPROMOC = :CDGRUPROMOC AND CDPRODUTO = :CDPRODUTO AND NRORG = :NRORG
    ";
}