<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class RelFichTecUtilProdServ {
	
	protected $entityManager;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager)  {
		$this->entityManager = $entityManager;
	}
	
	public function getDados($conditions){
		$params = array(
			'CDSUBPRODUTO' => $conditions['CDPRODUTO']
		);
		
		return $this->entityManager->getConnection()->fetchAll(self::GETPRODUTOS, $params);
	}
	    
	const GETPRODUTOS = "
        SELECT DISTINCT PR.NMPRODUTO, PR.CDPRODUTO, PR.CDARVPROD, 'Padrão' AS FILIAL, PR2.CDPRODUTO||' - '||PR2.NMPRODUTO AS NMPRODUTOCOMPO, PR2.CDARVPROD AS CDARQVPRODCOMPO
		  FROM PRODUTO PR, ROTFABRICA RT, PRODFILI PF, PRODUTO PR2
		 WHERE RT.CDPRODUTO = PR.CDPRODUTO
		   AND PF.CDPRODUTO = PR.CDPRODUTO
		   AND RT.CDPRODUTO = PF.CDPRODUTO
		   AND RT.CDSUBPRODUTO = PR2.CDPRODUTO
		   AND RT.CDSUBPRODUTO = :CDSUBPRODUTO
		UNION
		SELECT PR.NMPRODUTO, PR.CDPRODUTO, PR.CDARVPROD, RL.CDFILIAL||' - '||F.NMFILIAL AS FILIAL, PR2.CDPRODUTO||' - '||PR2.NMPRODUTO AS NMPRODUTOCOMPO, PR2.CDARVPROD AS CDARQVPRODCOMPO
		  FROM PRODUTO PR
		  JOIN ROTFABLOCAL RL
		    ON RL.CDPRODUTO    = PR.CDPRODUTO
		   JOIN FILIAL F
		    ON RL.CDFILIAL = F.CDFILIAL
		  JOIN PRODUTO PR2
		    ON RL.CDSUBPRODLOC = PR2.CDPRODUTO
		   WHERE RL.CDSUBPRODLOC = :CDSUBPRODUTO
		UNION
		SELECT PR.NMPRODUTO, PR.CDPRODUTO, PR.CDARVPROD, 'Itens Adicionais' AS FILIAL, PR2.CDPRODUTO||' - '||PR2.NMPRODUTO AS NMPRODUTOCOMPO, PR2.CDARVPROD AS CDARQVPRODCOMPO
		  FROM PRODUTO PR, PRODUTOADIC PA, PRODUTO PR2
		 WHERE PA.CDPRODUTO    = PR.CDPRODUTO
		    AND PA.CDSUBPRODUTO = PR2.CDPRODUTO
		   AND PA.CDSUBPRODUTO = :CDSUBPRODUTO
		   ORDER BY 3 
	";
}
